<template>
  <div class="app-container">
    <div v-if="show==0">

      <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="100px">
        <el-form-item label="货物名称" prop="cargoName">
          <el-input
            v-model="queryParams.cargoName"
            placeholder="请输入货物名称"
            clearable
            @keyup.enter.native="handleQuery"
          />
        </el-form-item>

        <el-form-item label="货主名称" prop="custName">
          <el-input
            v-model="queryParams.custName"
            placeholder="请输入货主名称"
            clearable
            @keyup.enter.native="handleQuery"
          />
        </el-form-item>
        <el-form-item>
          <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
          <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
        </el-form-item>
      </el-form>

      <el-row :gutter="10" class="mb8">
        <el-col :span="1.5">

        </el-col>
        <el-col :span="1.5">

        </el-col>
        <el-col :span="1.5">

        </el-col>
<!--        <el-col :span="1.5">
          <el-button
            type="warning"
            plain
            icon="el-icon-download"
            size="mini"
            @click="handleExport"
            v-hasPermi="['jxc:ckstock:export']"
          >导出
          </el-button>
        </el-col>-->
        <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
      </el-row>

      <el-table v-loading="loading" highlight-current-row :data="ckstockList" @sort-change="handleSortChange"
                @selection-change="handleSelectionChange" border>
        <el-table-column type="selection" width="55" align="center"/>
<!--          <el-table-column label="货物自然序号" align="center" prop="cargoNumber" sortable='custom'/>-->
          <el-table-column label="HS编号" align="center" prop="hsCode" sortable='custom'/>
          <el-table-column label="货物名称" align="center" prop="cargoName" sortable='custom'/>
          <el-table-column label="货主名称" align="center" prop="custName" sortable='custom' />
          <el-table-column label="数量" align="center" prop="cargoNum" sortable='custom' />
          <el-table-column label="重量" align="center" prop="cargoWt" sortable='custom' />
          <el-table-column label="体积" align="center" prop="cargoVol" sortable='custom' />
<!--          <el-table-column label="规格类型品质" align="center" prop="cargoSpec" sortable='custom' />-->
          <el-table-column label="原产国" align="center" prop="originCountry" sortable='custom'/>
<!--          <el-table-column label="盘点日期" align="center" prop="updateTime" sortable='custom'/>-->
          <el-table-column label="入库日期" align="center" prop="stockDate" sortable='custom'>
            <template slot-scope="{ row }">
              {{ formatDate(row.stockDate) }}
            </template>
          </el-table-column>
        <el-table-column label="操作" fixed="right" align="center" class-name="small-padding fixed-width" width="120px">
          <template slot-scope="scope">
            <el-button
              size="mini"
              type="text"
              icon="el-icon-edit"
              @click="handleUpdate(scope.row)"
              v-hasPermi="['jxc:ckstock:edit']"
            >库存明细
            </el-button>
          </template>
        </el-table-column>
      </el-table>
      <pagination
        :total="total"
        :page.sync="queryParams.pageNum"
        :limit.sync="queryParams.pageSize"
        @pagination="getList"
      />
    </div>

    <div v-if="show == 1 ">
      <div>
      <el-button @click="cancel" style="right: 3%;position:absolute;">返 回</el-button>
      <br>
        <br>
        <el-table v-loading="loading" highlight-current-row :data="ckstockDetailList" @sort-change="handleSortChange"
                  @selection-change="handleSelectionChange" border>
<!--          <el-table-column type="selection" width="55" align="center"/>-->

        <el-table-column label="单据信息" align="center">

          <el-table-column label="入库日期" align="center" prop="stockDate" width="180" sortable='custom'>
            <template slot-scope="scope">
              <span>{{ parseTime(scope.row.stockDate, '{y}-{m}-{d} {h}:{i}:{s}') }}</span>

            </template>
          </el-table-column>
          <el-table-column label="单据编号" align="center" prop="billNumber" sortable='custom' width="100"/>
        </el-table-column>
        <el-table-column label="船舶信息" align="center">

          <el-table-column label="航次号" align="center" prop="voyageNo" sortable='custom' width="100"/>
          <el-table-column label="船舶名称" align="center" prop="vesselName" sortable='custom' width="100"/>
        </el-table-column>
        <el-table-column label="货物信息" align="center">
          <el-table-column label="库场名称" align="center" prop="stockCode" sortable='custom' width="100">
            <template slot-scope="scope">
              <WarehouseName :stockCode="scope.row.stockCode"/>
            </template>
          </el-table-column>
          <el-table-column label="仓位名称" align="center" prop="stockName" sortable='custom' width="100"/>
          <el-table-column label="货主名称" align="center" prop="custName" sortable='custom' width="100"/>
          <el-table-column label="货物名称" align="center" prop="cargoName" sortable='custom' width="100"/>
          <el-table-column label="货物自然序号" align="center" prop="cargoNumber" sortable='custom' width="130" />
          <el-table-column label="商品料号" align="center" prop="itemNumber" sortable='custom' width="100" />
          <el-table-column label="电子账册项号" align="center" prop="bookNumber" sortable='custom' width="130"/>

          <el-table-column label="HS编号" align="center" prop="hsCode" sortable='custom' width="100"/>
          <el-table-column label="报关单号" align="center" prop="customsNo" sortable='custom' width="100"/>
          <el-table-column label="核注清单号" align="center" prop="listNumber" sortable='custom' width="130"/>

          <el-table-column label="货物价值" align="center" prop="cargoValue" sortable='custom' width="100"/>
          <el-table-column label="提运单号" align="center" prop="billNo" sortable='custom' width="100"/>
          <el-table-column label="规格类型品质" show-overflow-tooltip align="center" prop="cargoSpec" sortable='custom' min-width="200"/>
          <el-table-column label="原产国" align="center" prop="originCountry" sortable='custom' width="100"/>
          <el-table-column label="业务性质" align="center" prop="opType" sortable='custom' width="100">
            <template slot-scope="scope">
              <dict-tag :options="dict.type.sys_business_nature" :value="scope.row.opType"/>
            </template>
          </el-table-column>
          <el-table-column label="贸易性质" align="center" prop="tradType" sortable='custom' width="100">
            <template slot-scope="scope">
              <dict-tag :options="dict.type.sys_trade_nature" :value="scope.row.tradType"/>
            </template>
          </el-table-column>
          <el-table-column label="货物件数" align="center" prop="cargoNum" sortable='custom' width="130"/>
          <el-table-column label="货物重量" align="center" prop="cargoWt" sortable='custom' width="130"/>
          <el-table-column label="货物体积" align="center" prop="cargoVol" sortable='custom' width="130"/>

        </el-table-column>
          <el-table-column label="有效期至" align="center" prop="expiryDate" width="180" sortable='custom'>
            <template slot-scope="scope">
              <span>{{ parseTime(scope.row.expiryDate, '{y}-{m}-{d} {h}:{i}:{s}') }}</span>
            </template>
          </el-table-column>


      </el-table>
        <pagination
          :total="detailTotal"
          :page.sync="detailParams.pageNum"
          :limit.sync="detailParams.pageSize"
          @pagination="handleUpdate"
        />
      </div>
    </div>
  </div>
</template>

<script>
import {
  newList,
  getCkstock,
  delCkstock,
  addCkstock,
  updateCkstock,
  newListCkstock,
  pageListCkstock
} from '@/api/jxc/ckstock';
import {listStock} from "@/api/jxc/stock";
import {listCust} from "@/api/jxc/cust";
import {listCargo} from "@/api/jxc/cargo";
import {listVessel,} from "@/api/jxc/vessel";
import {listBmvoyage} from "@/api/jxc/bmvoyage";


export default {
  name: "Ckstock",
  dicts: ['sys_business_nature', 'sys_trade_nature'],
  data() {
    return {


      activeName: ['1', '2', '3'],
      show: 0,

      tableData: [{
        id: 3,
        cargoName: '铁',
        stockName: '1号库场',
        custName: '王晓敏',
        cargoNum: '1519 ',
        cargoWt: '11',
        cargoVol: '120',

      },{
        id: 31,
        cargoName: '铁',

        stockName: '1号库场',
        custName: '王晓敏',
        cargoNum: '519 ',
        cargoWt: '10',
        cargoVol: '100',
      },
      ],


      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 选中名字
      names: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 入库时间
      queryTime: [],
      // newListCkstockList
      newListCkstockList: [],
      // 船舶航次表格数据
      bmvoyageList: [],
      // 船舱表格数据
      vesselList: [],
      // 客户表格数据
      custList: [],
      // 货物表格数据
      cargoList: [],
      // 仓库表格数据
      stockList: [],
      // 仓库表格数据
      ckstockList: [],
      ckstockDetailList: [],
      detailTotal:0,
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        stockDate: null,
        billNumber: null,
        voyageId: null,
        voyageNo: null,
        vesselId: null,
        vesselName: null,
        cargoId: null,
        hsCode: null,
        cargoName: null,
        billNo: null,
        cargoSpec: null,
        originCountry: null,
        custId: null,
        custName: null,
        opType: null,
        tradType: null,
        cargoNum: null,
        cargoWt: null,
        cargoVol: null,
        stockId: null,
        stockCode: null,
        stockName: null,
        cargoValue:null,
        customsNo:null,
        listNumber:null,
        cargoNumber: null,
        itemNumber: null,
        bookNumber: null,
        expiryDate: null,

      },
      // 查询参数
      detailParams: {
        pageNum: 1,
        pageSize: 10,
        cargoId: null,

      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        stockId: [
          {required: true, message: "库场ID不能为空", trigger: "blur"}
        ],
        stockDate: [
          {required: true, message: "入库日期不能为空", trigger: "blur"}
        ],
        billNumber: [
          {required: true, message: "单据编号不能为空", trigger: "blur"}
        ],
        voyageNo: [
          {required: true, message: "航次号不能为空", trigger: "blur"}
        ],
        vesselName: [
          {required: true, message: "船舶名称不能为空", trigger: "blur"}
        ],
        cargoName: [
          {required: true, message: "货物名称不能为空", trigger: "blur"}
        ],
        billNo: [
          {required: true, message: "提运单号不能为空", trigger: "blur"}
        ],
        custName: [
          {required: true, message: "货主名称不能为空", trigger: "blur"}
        ],
        opType: [
          {required: true, message: "业务性质不能为空", trigger: "blur"}
        ],
        tradType: [
          {required: true, message: "贸易性质不能为空", trigger: "blur"}
        ],
        stockName: [
          {required: true, message: "库场名称不能为空", trigger: "blur"}
        ],
      }
    };
  },
  created() {
    this.getList();
    this.getStockList();
    this.getCustList();
    this.getCargoList();
    this.getVesselList();
    this.getBmvoyage();
    this.getNewListCkstock();


  },
  methods: {
    formatDate(timestamp) {
      const date = new Date(timestamp);
      return date.toISOString().split('T')[0];
    },
    getNewListCkstock() {
      let param = {};
      newListCkstock(param).then(response => {
        this.newListCkstockList = response.data;
      }).catch(e => {
      });
    },

    //航次
    setBmvoyageDetail(voyageId) {

      this.bmvoyageList.forEach(ele => {
        if (ele.id == voyageId) {
          this.form.voyageNo = ele.voyageNo;
          this.form.vesselName = ele.vesselName;
          this.form.deptId = ele.deptId;
          this.form.vesselId = ele.vesselId;
          this.form.netTon = ele.netTon;
          this.form.opType = ele.opType;


        }
      })
    },
    getBmvoyage() {
      let param = {};
      listBmvoyage(param).then(response => {
        this.bmvoyageList = response.data;
      }).catch(e => {
      });
    },

    //船舶
    setVesselDetail(vesselId) {
      console.log(vesselId);
      this.vesselList.forEach(ele => {
        if (ele.id == vesselId) {
          console.log("aa:", ele.vesselName);
          this.form.vesselName = ele.vesselName;

        }
      })
    },

    getVesselList() {
      let param = {};
      listVessel(param).then(response => {
        this.vesselList = response.data;
      }).catch(e => {
      });
    },


    //货物
    setCargoDetail(cargoId) {
      this.cargoList.forEach(ele => {
        if (ele.id == cargoId) {
          this.form.cargoName = ele.cargoName;
          this.form.hsCode = ele.hsCode;
          this.form.cargoSpec = ele.cargoSpec;
          this.form.originCountry = ele.originCountry;

        }
      })
    },

    getCargoList() {
      let param = {};
      listCargo(param).then(response => {
        this.cargoList = response.data;
      }).catch(e => {
      });
    },

    //客户
    setCustDetail(custId) {
      this.custList.forEach(ele => {
        if (ele.id == custId) {
          this.form.custName = ele.custName;
          this.form.custCode = ele.custCode;
        }
      })
    },

    getCustList() {
      let param = {};
      listCust(param).then(response => {
        this.custList = response.data;
      }).catch(e => {
      });
    },

    //仓库
    setStockDetail(stockId) {
      this.stockList.forEach(ele => {
        if (ele.id == stockId) {
          this.form.stockName = ele.stockName;
          this.form.stockCode = ele.stockCode;
        }
      })
    },

    getStockList() {
      let param = {};
      listStock(param).then(response => {
        this.stockList = response.data;
      }).catch(e => {
      });
    },

    /** 查询仓库库存列表 */
    getList() {
      this.loading = true;

      newList(this.queryParams).then(response => {
        this.ckstockList = response.rows;
        this.total = response.total;
        this.loading = false;
      }).catch(e => {
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.show = 0;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        stockDate: null,
        billNumber: null,
        voyageId: null,
        voyageNo: null,
        vesselId: null,
        vesselName: null,
        cargoId: null,
        hsCode: null,
        cargoName: null,
        billNo: null,
        cargoSpec: null,
        originCountry: null,
        custId: null,
        custName: null,
        opType: null,
        tradType: null,
        cargoNum: null,
        cargoWt: null,
        cargoVol: null,
        stockId: null,
        stockCode: null,
        stockName: null,
        remark: null,
        cargoValue:null,
        customsNo:null,
        listNumber:null,
        cargoNumber: null,
        itemNumber: null,
        bookNumber: null,
        expiryDate: null,
      };
      this.resetForm("form");
    },
    //排序
    handleSortChange(col) {
      this.$sortBy(col, this.queryParams);
      this.getList();
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");

      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id);
      this.names = selection.map(item => item.id);
      this.single = selection.length !== 1;
      this.multiple = !selection.length;
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加仓库库存";
    },
    /** 详情按钮操作 */
    handleUpdate(row) {
      if(row){
        this.detailParams.cargoId = row.cargoId,
        this.detailParams.custId = row.custId
      }
      pageListCkstock(this.detailParams).then(response => {
        this.ckstockDetailList = response.rows;
        this.detailTotal = response.total;
        this.show = 1;
      }).catch(e => {
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updateCkstock(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addCkstock(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      const names = row.id || this.names;
      this.$modal.confirm('是否确认删除"' + row.billNumber + '"的数据项？').then(function () {
        return delCkstock(ids);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {
      });
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('jxc/ckstock/export', {
        ...this.queryParams
      }, `库场货物查询_${new Date().getTime()}.xlsx`)
    }
  }
};
</script>
